#include <bits/stdc++.h>

using namespace std;

class DSU {
    vector<int> R;
public:
    DSU(int N) : R(N, -1) {}
    int holvan(int x) {
        if (R[x] < 0) {
            return x;
        }
        return R[x] = holvan(R[x]);
    }
    int unio(int a, int b) {
        a = holvan(a);
        b = holvan(b);
        if (a == b)
            return a;
        if (R[a] < R[b]) { // a nagyobb elemszamu
            R[a] += R[b];
            R[b] = a;
            return a;
        } else {
            R[b] += R[a];
            R[a] = b;
            return b;
        }
    }
};

vector<int> comp;
vector<int> from_special; // 0...316  -> 0...N-1
unordered_map<int, int> to_special; // 0..N-1 -> 0..316
vector<vector<int>> G;
vector<int> D;
DSU a = DSU(0); // O(sqrtN)
unordered_set<int> S;


bool is_special(int a) {
    auto it = to_special.find(a);
    return it != to_special.end();
}

// returns component
int dfs(int a, int c) {
    if (comp[a] != -1)
        return comp[a];
    if (is_special(a)) {
        return to_special[a];
    }
    int c = -1;
    for (int b: G[a]) {
        if (is_special(b)) {
            if (c == -1) {
                c = to_special[b];
            } else {
                c = a.unio(to_special[b], c);
            }
        }
    }
    return c;
}

int main() {
    int N,M,Q;
    cin.sync_with_stdio(false);
    cin.tie(NULL);
    cin >> N >> M >> Q;
    comp.resize(N);
    G.resize(N);
    D.resize(N);
    for (int i = 0; i < M; i++) {
        int a,b;
        cin >> a >> b;
        a--;b--;
        G[a].push_back(b);
        G[b].push_back(a);
        D[a]++;
        D[b]++;
    }
    // gyokN db megtalalasa
    int sn = 0;
    for (int i = 0; i < N; i++) { // O(N)
        if (D[i] > 316) {
            to_special[i] = from_special.size();
            from_special.push_back(i);
        }
    }
    int sN = from_special.size();
    vector<vector<int>> X(sN, vector<int>(sN));
    for (int si = 0; si < from_special.size(); si++) { // O(M)
        int i = from_special[si];
        for (int b: G[i]) {
            auto it = to_special.find(b);
            if (it == to_special.end()) {
                continue;
            }
            int sb = it->second;
            // sb -> si !!!
        }
    }

    for (int i = 0; i < Q; i++) {
        int K;
        cin >> K;
        vector<bool> volte(N);
        a = DSU(N); // O(gyokN)
        S.clear();
        vector<int> XX(N);
        for (int i = 0; i < K; i++) {
            int a;
            cin >> a;
            a--;
            S.insert(a);
            // <= gyokN
            if (is_special(a)) {
                comp[a] = to_special[a];
                XX.push_back(to_special[a]);
            }
        }
        for (int a: XX) {
            for (int b: XX) {
                a.unio(b);
            }
        }
        int s = 0;
        for (int i : S) {
            if (dfs(i, -1) == -1) {
                s += 1;
            } else {

            }
        }
    }
}